#include <conio.h>
#include <graphics.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

void countlinescols (char *s,int &lines,int &cols)
 {                              //broi redowete i max. simwoli na red w
				 //niza s;
  cols = 0;
  int crrcols = 0;
  lines = 0;                    //broj simwoli w tekushtiq red
  int slen = strlen(s);
  for (int c = 0; c < slen;c++)
  {
     crrcols++;
     if (s[c] == '\n' || c == slen-1)
     {
       lines++;
       if (crrcols > cols)
	  cols = crrcols;
       crrcols = 0;
     }
  }
}

int countcols (int n,char **items)
 {                         //broj maksimalniq broj simwoli w masiw ot nizowe
    int max = 0;
    for (int c = 0;c < n;c++)
      if (strlen(items[c]) > max)
	  max = strlen (items[c]);
    return max;
 }

int isdigit (char c)
 {                   //prowerqwa dali c e cifra
   return c >= '0' && c <= '9';
 }


int is10digits (char *s)
 {                          //Proverka za desetcifreno chislo
  if (strlen(s) != 10)
    return 0;
  int c;
  for (c =0; c < strlen(s) && isdigit(s[c]);c++);

  return c == strlen(s);
 }
int isdate (char *s)
 {                           //prowerqwa dali s e data
   return strlen(s) == 8 &&
	  isdigit(s[0]) &&
	  isdigit(s[1]) &&
	  isdigit(s[3]) &&
	  isdigit(s[4]) &&
	  isdigit(s[6]) &&
	  isdigit(s[7]) &&
	  s[2] == '.' &&
	  s[5] == '.';
 }

int isfloat (char *s)
 {                           //prowerqwa dali s e float chislo
  for (int c = 0; c < strlen (s) && (isdigit (s[c]) || s[c] == '.');c++);
  if (c < strlen(s))
    return 0;

  return atof(s) != 0 || s[0] == '0';
 }

struct colorinfo            //Prozoreqni funkcii
 {
   char object[20];
   int color;
 };
			//globalen masiw, kojto sadyrza kakwi sa
			//cvetowete na otdelnite obekti
colorinfo MyColors[] = {"WindowFrame",LIGHTRED,
		      "WindowFore",GREEN,
		      "WindowTitle",YELLOW,
		      "InputFore",YELLOW,
		      "ScreenBColor",BLACK,
		      "MenuSelBColor",LIGHTRED,
		      "MenuSelFColor",WHITE};
void UpdateColor (char *name, int value)
 {                    //namira w MyColor elementa za obekta name (ako ima)
		      //i zamenq cweta s value.
   int c;
   for (c = 0; c < 7 && strcmp (MyColors[c].object,name) != 0;c++);
   if (c < 7)
     MyColors[c].color = value;
 }

void ReadColorsFromFile (char *filename)
 {
   FILE *f = fopen (filename,"rt");
   if (f==NULL)
     return;
   char name[20];
   int value;
   while (!feof(f) && fscanf (f,"%s %d",name,&value))
      UpdateColor (name,value);
 }

#define _WINDOW_FRAME MyColors[0].color
#define _WINDOW_FORE  MyColors[1].color
#define _WINDOW_TITLE MyColors[2].color
#define _INPUT_FORE MyColors[3].color
#define _SCREEN_BCOLOR MyColors[4].color
#define _MENUSEL_BCOLOR MyColors[5].color
#define _MENUSEL_FCOLOR MyColors[6].color
#define _WTITLE_XOFS 10
#define _WTITLE_YOFS -5
#define _LETTER_H 12
#define _LETTER_W 8
#define _WTEXT_XOFS 10
#define _WTEXT_YOFS 10
#define _MAX_READSYMBOLS 60

struct mywindow
 {
  int x,y,w,h;
  char title[100];
 };

struct mymenu
 {               //masiw ot nizowe za izborite, broj izbor
   mywindow box;
   char **items;
   int itemsn;
 };
mywindow createwindow (int x, int y, int w, int h, char *title)
 {                            //inicializaciq na window strukturata
   mywindow newwindow;
   newwindow.x = x;
   newwindow.y = y;
   newwindow.h = h;
   newwindow.w = w;
   strcpy (newwindow.title,title);
   return newwindow;
 }

void openwindow (mywindow &w)
 {                            //za ramkata na prozoreca
    setcolor (_WINDOW_FRAME);
    line (w.x,w.y,w.x+w.w,w.y);
    line (w.x+w.w,w.y,w.x+w.w,w.y+w.h);
    line (w.x+w.w,w.y+w.h,w.x,w.y+w.h);
    line (w.x,w.y+w.h,w.x,w.y);
    setcolor (_WINDOW_TITLE);  //zaglavie
    outtextxy (w.x+_WTITLE_XOFS,w.y+_WTITLE_YOFS,w.title);

 }

void closewindow (mywindow &w)
 {
    setcolor (_SCREEN_BCOLOR);
    setfillstyle (SOLID_FILL,_SCREEN_BCOLOR);
    int points[] = {w.x-_WTITLE_XOFS,w.y+_WTITLE_YOFS,
		    w.x+w.w+_WTITLE_XOFS,w.y+_WTITLE_YOFS,
		    w.x+w.w+_WTITLE_XOFS,w.y+w.h-_WTITLE_YOFS,
		    w.x-_WTITLE_XOFS,w.y+w.h-_WTITLE_YOFS};
    fillpoly (4,points);
 }

void displaylines (mywindow &box,char *message,int lines)
 {                            //zapylvame prozoreca
   int crrlinen = 0,n=0;
   char   crrline[100];
				//nomer i sysydzanie na tekushtiq red
   setcolor (_WINDOW_FORE);
   while (crrlinen < lines)
    {
      if (strstr (message,"\n"))
	{
	  n = strstr(message,"\n")-message;
	  strncpy (crrline,message,n);
	  message += n + 1;
	  crrline[n] = 0;
	 }
	  else
	    strcpy (crrline,message);
	    outtextxy (box.x+_WTEXT_XOFS,box.y+_WTEXT_YOFS+_LETTER_H*crrlinen,crrline);
	    crrlinen++;
    }

 }

void showmessage (int x,int y,char *title,char *message)
 {                                 //za syobshtenie v prozoreca
    int lines,cols;
    countlinescols (message,lines,cols);
					//syzdawame prozorec
    mywindow box = createwindow (x,y,
				 cols*_LETTER_W + _WTEXT_XOFS*2,
				 lines*_LETTER_H + _WTEXT_YOFS*2,title);
    openwindow (box);
    displaylines (box,message,lines);
    getch ();
    closewindow (box);

 }
int graphread (char *s,int maxchars)     //za chetene
 {                     //chete niz do enter. Wryshta nula pri escape.
		       //nizyt moze da ima naj-mnogo maxchars simwoli
   char c;
   int count = 0,origx = getx();    //broj simvoli v nachaloto
   strcpy (s,"");
   setcolor (_INPUT_FORE);
   do
    {
      c = getch ();
      if (c >= 32)
       {            //ako e natisnata bukwa -dobawqme kym niza i
		    //izpiswame simwola
	 s[count] = c;
	 count++;
	 s[count] = 0;
	 outtextxy (origx,gety(),s);
       }

     } while (c != 13 && c != 27 && count < maxchars);
		   //chete do enter ili do escape
    return c != 27;
 }
int textinputform (char *question,char *result)
 {		       //wywezdane na tekstow result.
   int qlines,qcols;
   countlinescols (question,qlines,qcols);
   mywindow box = createwindow (10,
				getmaxy()/2-((qlines+1)/2)*_LETTER_H,
				getmaxx()-20,
				(qlines+1)*_LETTER_H+_WTEXT_YOFS*3,"input");
   openwindow (box);
			//risuwane na wyprosa
   displaylines (box,question,qlines);
   moveto (10+_WTEXT_XOFS,box.y + qlines*_LETTER_H+_WTEXT_YOFS*2);
   int ok = graphread (result,_MAX_READSYMBOLS);
   closewindow (box);
   return ok;
 }
mymenu createmenu (int x, int y,int itemsn,char **items)
 {
   mymenu menu;
   menu.box = createwindow (x,y,
			    countcols(itemsn,items)*_LETTER_W+_WTEXT_XOFS*2,
			    itemsn*_LETTER_H+_WTEXT_XOFS*2,"select");
    menu.itemsn = itemsn;
    menu.items = items;
    return menu;
 }

void drawitem (mymenu &menu,int i,int bcolor,int fcolor)
 {		      //risuwa i-tata mmenu alternativa sys syotw.
		      //cvqt na fona i cvqt na simwolite
    setcolor (_SCREEN_BCOLOR);
    setfillstyle (SOLID_FILL,bcolor);
    int points[] = {menu.box.x+_WTEXT_XOFS,
		    menu.box.y+_WTEXT_YOFS+i*_LETTER_H,

		    menu.box.x+menu.box.w-_WTEXT_XOFS,
		    menu.box.y+_WTEXT_YOFS+i*_LETTER_H,

		    menu.box.x+menu.box.w-_WTEXT_XOFS,
		    menu.box.y+_WTEXT_YOFS+(i+1)*_LETTER_H,

		    menu.box.x+_WTEXT_XOFS,
		    menu.box.y+_WTEXT_YOFS+(i+1)*_LETTER_H};

    fillpoly (4,points);
    setcolor (fcolor);
			//izpiswane na teksta na syotw. poziciq
    outtextxy (menu.box.x+_WTEXT_XOFS,
	       menu.box.y+_WTEXT_YOFS+i*_LETTER_H,
	       menu.items[i]);
 }

int getselection (mymenu &menu)
 {
			 //otwarq menu i go zadejstwa
    openwindow (menu.box);
    int c = 0;
    drawitem (menu,0,_MENUSEL_BCOLOR,_MENUSEL_FCOLOR);
    for (c = 1; c < menu.itemsn;c++)
	  drawitem (menu,c,_SCREEN_BCOLOR,_WINDOW_FORE);
			   //spira vavejdaneto pri Enter ili Escape
   int current = 0;
   do
    {
       c = getch();
       if (!c)
	{
	   c = getch();
	   drawitem (menu,current,_SCREEN_BCOLOR,_WINDOW_FORE);
	      switch (c)
		 {                //ako e natisnata nqkoq strelka - reagirame
		  case 72: if (current>0)
			       //ako weche ne e izbrana imenno naj-gornata
			    current--;
			    break;
		   case 80:
			    if (current < menu.itemsn-1)
			    current++;
			    break;
		  }

	   drawitem (menu,current,_MENUSEL_BCOLOR,_MENUSEL_FCOLOR);

	}

    } while (c != 13 && c != 27);
    if (c == 27)
       return -1;
       else
	 return current;  //t.e. kogato e natisnat Enter
 }


void closemenu (mymenu &menu)
 {
   closewindow (menu.box);
 }

struct fdata
 {
   char no[11],name[61];
   float prize;
   int quantity;
   char date[11],providername[41],pphone[11],pstreet[31],ptown[14];
 };
int readfromfile (FILE *f,fdata &result)
 {
   return !feof (f) && fread (&result,sizeof(fdata),1,f); //ako ne sme
				       //v kraya ili sme procheli neshto
 }
void writetofile (FILE *f, fdata data)
 {
   fwrite (&data,sizeof(fdata),1,f);
 }
void appendtofile (FILE *f, fdata data)    //za dobavyane na danni
 {
   fseek (f,0,SEEK_END);
   fwrite (&data,sizeof(fdata),1,f);
 }
int isunique (FILE *f,char *no)
 {                              //proverka za unikalnost
   struct fdata entry;
   fseek (f,0,SEEK_SET);
   int found = 0;
   while (readfromfile (f,entry) && !found)
       found = strcmp (entry.no,no) == 0;
   return !found;
 }

void addentry (FILE *f)
 {                               //dobawq nowa stoka w sklada
    fdata newentry;              //za wsqko pole - wywezdane
    char s[100];
    int escape=0,unique = 0,correct = 0;
    do
     {
       escape = !textinputform ("Molq vyvedete nomer na novata stoka",
				newentry.no);
       unique = escape || isunique (f,newentry.no);
		       //pri escape ne prowerqwame za unikalnost
       if (!unique)
	 showmessage (10,10,"error","Stoka ne e s unikalen nomer");
       correct = is10digits (newentry.no);
       if (!escape && unique && !correct)
	  showmessage (10,30,"error","Nomeryt ne e desetcifreno chislo!");

     }  while (escape || !unique ||!correct);
    int ok = 0;
    while (!textinputform ("Molq vyvedete naimenowanie na stokata",
				newentry.name));
    ok = 0;
    while (!ok)
      {
	ok = textinputform ("Molq vyvedete ed. cena na stokata",s);
	if (ok && !isfloat (s))
	{
	 ok = 0;
	 showmessage (10,40,"error","Trqbwa da wywedete chislo!");
	}
     }
    newentry.prize = atof (s);
    while (!textinputform ("Molq vyvedete kolichestwo na stokata",s));
    newentry.quantity = atoi(s);
    ok = 0;
    while (!ok)
     {
       ok = textinputform ("Molq vyvedete data na proizwodstwo na stokata",
				newentry.date);
       if (ok && !isdate (newentry.date))
       {
	 ok = 0;
	 showmessage (10,40,"error","Molq wywedete korektna data");
       }
     }
    while (!textinputform ("Molq vyvedete ime na dostavchika",
				newentry.providername));
    while (!textinputform ("Molq vyvedete grad na dostavchika",
				newentry.ptown));
    while (!textinputform ("Molq vyvedete ulica na dostavchika",
				newentry.pstreet));
    while (!textinputform ("Molq vyvedete telefon na dostavchika",
				newentry.pphone));

    appendtofile (f,newentry);
 }
void changeq (FILE *data)      //za promyana na nalichnost
 {
  char n[100];
  if (!textinputform ("Molq wywedete identifikacionen nomer",n))
    return;

  fseek (data,0,SEEK_SET);
		//recordpos shte pazi poziciqta na nachaloto na
		//zapisa, kojtoi ni tyrqbwa
  long recordpos = 0;
  fdata entry;
  do
    recordpos = ftell (data);
   while (readfromfile (data,entry) && strcmp (entry.no,n) != 0);
  if (strcmp (entry.no,n) != 0)
     {
      showmessage (10,10,"error","Stoka s takyw identifikacionen nomer ne e otkrita");
      return;
     }

  char s[100];
  while (!textinputform ("Molq wywedete kak da se promeni kolichestwoto",s));
  entry.quantity += atoi(s);
  fseek (data,recordpos,SEEK_SET);
  writetofile (data,entry);
 }
void showentryinfo (fdata data)
 {		                 //pokazwa na informaciq za dadenata stoka
    char info [1000] = "";
    sprintf(info,"Nomer na stokata :%s\n"
		 "Naimenowanie     :%s\n"
		 "Ed.cena          :%.4f\n"
		 "Kolichestwo           :%d\n"
		 "Data na proizwodstwo  :%s\n"
		 "Ime na dostavchik     :%s\n"
		 "Adres na dostawchik   :%s,%s,tel.%s",
		 data.no,data.name,data.prize,data.quantity,
		 data.date,data.providername,data.ptown,
		 data.pstreet,data.pphone);
    showmessage (50,100,"Informaciq!",info);
 }

void providerinfo (FILE *data)
 {                             //inf. za proizvoditel
   char town[100];
   if (!textinputform ("molq wywedete grad na dostawchicite",town))
      return;

   fseek (data,0,SEEK_SET);
   fdata entry;
   while (readfromfile (data,entry))
      if (strcmp (entry.ptown,town) == 0)
	 showentryinfo (entry);
  }
void showentriesinfo (FILE *f)
 {                     //pokazwa informaciq za stokite ot daden  proizwoditel
   char provider[100];
   if (!textinputform("Molq wywedete ime na proizwoditel",provider))
       return;

   fdata entry;
   fseek (f,0,SEEK_SET);
   while (readfromfile (f,entry))     //izcherpwame wsichki stoki w sklada
	if (strcmp (entry.providername,provider) == 0)
			//ako tazi stoka trqbqa da q pokazwame
	  showentryinfo (entry);
  }


void start ()
 {
    ReadColorsFromFile ("init.txt");
    char *mainitems[] = {"Dobavqne na stoka v sklada!",
			  "Promqna na nalichnost!",
			  "Informaciq za stoka!",
			  "Infprmaciq za dostavchici!",
			  "Izhod!"
			 };
    mymenu mainmenu = createmenu (400,10,5,mainitems);
    FILE *data = fopen ("data.dat","rb+");
     if (!data)
		//ako fajlyt wse oshte ne systestwuwa
	data = fopen ("data.dat","wb+");
     if (!data)
       {
	 showmessage (10,10,"error","Nevyzmozno otvarqne na fajl!");
	 return;
       }

    int selection = 0;
    while (selection != -1 && selection != 4)
       {                              	 //do "izhod" ili escape
	 selection = getselection(mainmenu);
	 switch (selection)
	     {
	       case 0: addentry (data);
		       break;
	       case 1: changeq (data);
		       break;
	       case 2: showentriesinfo (data);
		       break;
	       case 3: providerinfo (data);
		       break;
	    }
      }

    fclose (data);
    closemenu (mainmenu);
 }

void initialize ()                          //za graf.rejim
 {
   int gdriver = DETECT, gmode = VGAHI  , errorcode;
   initgraph(&gdriver, &gmode, "proba");

 }
void restore ()
 {
   closegraph ();
 }
void main ()
 {
   initialize ();
   start ();
   restore();
 }
